(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/esm/slicedToArray'), require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/esm/slicedToArray', 'react'], factory) :
  (global = global || self, factory(global.UseEvents = {}, global._slicedToArray, global.React));
}(this, function (exports, _slicedToArray, React) { 'use strict';

  _slicedToArray = _slicedToArray && _slicedToArray.hasOwnProperty('default') ? _slicedToArray['default'] : _slicedToArray;

  var useActive = function useActive() {
    var _React$useState = React.useState(false),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        isActive = _React$useState2[0],
        setActive = _React$useState2[1];

    var bind = {
      onMouseDown: function onMouseDown(e) {
        return setActive(true);
      },
      onMouseUp: function onMouseUp(e) {
        return setActive(false);
      }
    };
    return [isActive, bind];
  };

  var useFocus = function useFocus() {
    var _React$useState = React.useState(false),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        isFocused = _React$useState2[0],
        setFocused = _React$useState2[1];

    var bind = {
      onFocus: function onFocus(e) {
        return setFocused(true);
      },
      onBlur: function onBlur(e) {
        return setFocused(false);
      }
    };
    return [isFocused, bind];
  };

  var useHover = function useHover() {
    var _React$useState = React.useState(false),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        isHovered = _React$useState2[0],
        setHovered = _React$useState2[1];

    var bind = {
      onMouseEnter: function onMouseEnter(e) {
        return setHovered(true);
      },
      onMouseLeave: function onMouseLeave(e) {
        return setHovered(false);
      }
    };
    return [isHovered, bind];
  };

  var useTouch = function useTouch() {
    var _React$useState = React.useState(false),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        isTouched = _React$useState2[0],
        setTouched = _React$useState2[1];

    var bind = {
      onTouchStart: function onTouchStart(e) {
        return setTouched(true);
      },
      onTouchEnd: function onTouchEnd(e) {
        return setTouched(false);
      }
    };
    return [isTouched, bind];
  };

  var useClickOutside = function useClickOutside(ref, onClickOutside) {
    var _React$useState = React.useState(false),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        isActive = _React$useState2[0],
        setActive = _React$useState2[1];

    var mousedown = function mousedown(e) {
      var current = ref.current;

      if (current !== null && !current.contains(e.target)) {
        setActive(true);
        onClickOutside(e);
      }
    };

    var mouseup = function mouseup(e) {
      var current = ref.current;

      if (current !== null && !current.contains(e.target)) {
        setActive(false);
      }
    };

    React.useEffect(function () {
      document.addEventListener('mousedown', mousedown);
      document.addEventListener('mouseup', mouseup);
      return function () {
        document.removeEventListener('mousedown', mousedown);
        document.removeEventListener('mouseup', mouseup);
      };
    }, []);
    return [isActive];
  };

  var useMousePosition = function useMousePosition() {
    var _React$useState = React.useState(0),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        x = _React$useState2[0],
        setX = _React$useState2[1];

    var _React$useState3 = React.useState(0),
        _React$useState4 = _slicedToArray(_React$useState3, 2),
        y = _React$useState4[0],
        setY = _React$useState4[1];

    var bind = {
      onMouseMove: function onMouseMove(_ref) {
        var _ref$nativeEvent = _ref.nativeEvent,
            offsetX = _ref$nativeEvent.offsetX,
            offsetY = _ref$nativeEvent.offsetY;
        setX(offsetX);
        setY(offsetY);
      }
    };
    return [x, y, bind];
  };

  exports.useActive = useActive;
  exports.useFocus = useFocus;
  exports.useHover = useHover;
  exports.useTouch = useTouch;
  exports.useClickOutside = useClickOutside;
  exports.useMousePosition = useMousePosition;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
